"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ConsoleManager {
    consoles = new Map();
    logger;
    constructor(logger) {
        this.logger = logger;
    }
    registerConsole(desc) {
        this.consoles.set(desc.getConsoleLabel(), desc);
        this.logger.debug(`Registered: ${desc.getConsoleLabel()}`);
    }
    getConsole(tag) {
        this.logger.debug(`Constructing: ${tag}`);
        return this.consoles.get(tag);
    }
    getAllConsoleTags() {
        let arr = [];
        this.consoles.forEach((c, key) => {
            arr.push(key);
        });
        return arr;
    }
}
exports.default = ConsoleManager;
//# sourceMappingURL=ConsoleManager.js.map