"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MupenDescriptor = void 0;
const FakeMupen_1 = require("./FakeMupen");
const N64_1 = __importDefault(require("./N64"));
class MupenDescriptor {
    constructConsole(side, rom, logger, lobby, config) {
        switch (side) {
            case 0 /* ProxySide.CLIENT */:
                return new N64_1.default(rom, logger, lobby, config);
            case 1 /* ProxySide.SERVER */:
                return new FakeMupen_1.FakeMupen(rom, logger, lobby);
            default:
                return {};
        }
    }
    getConsoleLabel() {
        return "Mupen64Plus";
    }
}
exports.MupenDescriptor = MupenDescriptor;
//# sourceMappingURL=MupenDescriptor.js.map