"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LobbyManager = void 0;
const LobbyObjects_1 = require("./LobbyObjects");
const NetworkingEventBus_1 = require("./NetworkingEventBus");
class LobbyManager {
    getLobbyStorage(lobbyName, plugin) {
        let evt = new LobbyObjects_1.getLobbyStorage_event(lobbyName, plugin);
        NetworkingEventBus_1.NetworkingEventBusServer.emit('getLobbyStorage', evt);
        return evt.obj;
    }
    createLobbyStorage(lobbyName, plugin, obj) {
        NetworkingEventBus_1.NetworkingEventBusServer.emit('createLobbyStorage', new LobbyObjects_1.createLobbyStorage_event(lobbyName, plugin, obj));
    }
    getAllLobbies() {
        let evt = { r: {} };
        NetworkingEventBus_1.NetworkingEventBusServer.emit('getAllLobbies', evt);
        return evt.r;
    }
}
exports.LobbyManager = LobbyManager;
//# sourceMappingURL=LobbyManager.js.map